#if !defined __KIRI_CMOS_H__
#define __KIRI_CMOS_H__

/* IO index */
#define	CMOS_INDEX_PORT						0x72
#define	CMOS_DATA_PORT						0x73

/* Wake on lan setting */
#define WOL_OFFSET								0x70
#define WOL_ENABLE								0x00
#define WOL_DISABLE								0x01

/* AC power loss setting */
#define	AC_POWER_LOSS_OFFSET			0x71
#define AC_POWER_LOSS_POWER_OFF 	0x00
#define AC_POWER_LOSS_POWER_ON  	0x01
#define AC_POWER_LOSS_LAST_STATE	0x02

/* CMOS setting */
#define CMOS_CHANGE_OFFSET				0x73
#define CMOS_CHANGE_ENABLE				0x01

/* WOL and ACPOWERLOSS registers of ICH10R */
#define INTEL_PCH_C206_VID				0x8086
#define INTEL_PCH_C206_DID				0x1C56
#define PMBASE										0x40
#define PM1_STS										0x00
#define PM1_EN										0x02
#define GEN_PMCON_3								0xA4

/* Buffalo used */
#if defined(CONFIG_BUFFALO_PLATFORM)
#define PID_OFFSET_CRC	0x75
#define PID_OFFSET_1	0x76
#define PID_OFFSET_2	0x77
#define PID_OFFSET_3	0x78
#define PID_OFFSET_4	0x79

#define REGION_OFFSET_CRC	0x7A
#define REGION_OFFSET		0x7B

// Reserved offset 0x7C
#else
#define PID_OFFSET_1							0x76
#define PID_OFFSET_2							0x77
#define PID_OFFSET_3							0x78
#define PID_OFFSET_4							0x79
#define REGION_OFFSET							0x75

// Reserved offset 0x7A~0x7C
#endif


/* IOCTL interface command */
#define GET_WOL										0x1
#define SET_WOL										0x2
#define GET_ACPOWER							  0x3
#define SET_ACPOWER								0x4
#define GET_PID										0x5
#define SET_PID										0x6
#define GET_REGION								0x7
#define SET_REGION								0x8


/* Common section */
#define kiri_cmos_major						124
#define	DEVNAME										"kiri_cmos"

uint32_t kiri_get_pid(void);

#endif
