#include <linux/module.h>
#include <linux/device.h>
#include "kiri_common.h"

struct class *kiri_cls;
static unsigned long ref_count = 0;

/*******************************************************************************
* function: KiriClassGet
* argument:
* retvalue:
* description:
*******************************************************************************/
struct class *KiriClassGet(void)
{
        struct class *tmp_cls;

        if(kiri_cls)
		goto __return_with_pointer;

        tmp_cls = class_create(THIS_MODULE, "kiri");
        if(IS_ERR(tmp_cls)) {
                printk("%s : class_create failed.", __FUNCTION__);
                return NULL;
        }
        kiri_cls = tmp_cls;

__return_with_pointer:
	ref_count++;
        return kiri_cls;
}

void KiriClassDestroy(void)
{
	if(ref_count == 0)
		printk("Warn!!! %s is called instead of ref_count == 0\n", __FUNCTION__);
	else
		ref_count--;

	if(ref_count == 0)
		class_destroy(kiri_cls);
}
