#if !defined __KIRI_FAN_H__
#define __KIRI_FAN_H__

/* IT8721 Registers Section */
#define CONFIG_ADDR_PORT	       	0x2E
#define CONFIG_DATA_PORT	       	0x2F
#define IT87_LDN_ADDR	       		0x07
#define	IT87_EC_LDN			0x04

/* ITE8721 EC Fan Registers */
#define IT87_EC_FAN_MAIN_CTL	   	0x13
#define IT87_EC_FAN_CTL		       	0x14

/* ITE8721 EC Fan Tachometer Registers */
#define IT87_EC_FAN_TACO1		0x0E // SYS1
#define IT87_EC_FAN_TACO2		0x0F // SYS2
#define IT87_EC_FAN_TACO3		0x0D // SYS3(CPU)
/*
#define IT87_EC_FAN_TACO4		0x80 // SYS3
#define IT87_EC_FAN_TACO5		0x82 // SYS4
*/
#define IT87_EC_FAN_TACO1_EXT		0x19
#define IT87_EC_FAN_TACO2_EXT		0x1A
#define IT87_EC_FAN_TACO3_EXT		0x18
/*
#define IT87_EC_FAN_TACO4_EXT		0x81
#define IT87_EC_FAN_TACO5_EXT		0x83
*/

/* Set the type of PWM control function */
#define IT87_EC_FAN_PWM1		0x16
#define IT87_EC_FAN_PWM2		0x17
#define IT87_EC_FAN_PWM3		0x15

/* set the fan speed value */
#define IT87_EC_FAN_SMART_PWM1		0x6B
#define IT87_EC_FAN_SMART_PWM2		0x73
#define IT87_EC_FAN_SMART_PWM3		0x63

/* ITE8721 EC Temprature Registers */
#define IT87_EC_TMPIN1			0x29 // CPU
#define IT87_EC_TMPIN2			0x2A // HDDTIN(Q278)
#define IT87_EC_TMPIN3			0x2B // SYSTIN(Q276)


/* Common Section */
#define kiri_fan_major						125
#define kiri_fan_minor						0
#define dev_count           			1
#define	DEVNAME										"kiri_fan"

struct fan_info_st
{
	unsigned char reg;
	unsigned char reg_ext;
	unsigned char reg_smart_pwm;
	unsigned char reg_pwm;
	unsigned char offset;
};

struct temp_info_st
{
	unsigned char reg;
};

/* IOCTL interface command */
#define GET_TEMP_CMD_BASE					0x100
#define GET_FAN_CMD_BASE					0x200
#define SET_FAN_CMD_BASE					0x400
#define IOCTL_CMD_MASK						0xF00

#endif
